Merge remote-tracking branch 'origin/pr/259'
[grml-debootstrap.git] / grml-debootstrap
index d00dc0c..581a74f 100755 (executable)
@@ -251,14 +251,14 @@ cleanup() {
     einfo "Removing ${STAGES}" ; rmdir "$STAGES" || eend $?
   fi
 
-  if [ -n "$ARM_EFI_TARGET" ]; then
-    umount "${MNTPOINT}/boot/efi" >/dev/null 2>&1
+  if findmnt "${MNTPOINT}"/boot/efi &>/dev/null ; then
+    umount "${MNTPOINT}"/boot/efi
   fi
 
   # Remove temporary mountpoint again
   if echo "$MNTPOINT" | grep -q '/mnt/debootstrap\.' ; then
     if [ -d "$MNTPOINT" ] ; then
-      rmdir "$MNTPOINT"
+      rmdir "$MNTPOINT" || true
     fi
   fi
 
@@ -272,17 +272,17 @@ cleanup() {
         fi
       done
 
-      [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount -a >/dev/null 2>&1
+      [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount -a >/dev/null 2>&1 || true
 
       # ugly, but make sure we really don't leave anything (/proc /proc and
       # /dev /dev are intended, trying to work around timing issues, see #657023)
       for ARG in /run/udev /sys /proc /proc /dev/pts /dev/pts /dev /dev ; do
-        [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount $ARG >/dev/null 2>&1
-        umount "$MNTPOINT"/$ARG >/dev/null 2>&1
+        [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount $ARG >/dev/null 2>&1 || true
+        umount "$MNTPOINT"/$ARG >/dev/null 2>&1 || true
       done
 
       if [ -n "$ISODIR" ] ; then
-        [ -d "$MNTPOINT/$ISODIR" ] && umount "$MNTPOINT/$ISODIR" >/dev/null 2>&1
+        [ -d "$MNTPOINT/$ISODIR" ] && umount "$MNTPOINT/$ISODIR" >/dev/null 2>&1 || true
       fi
 
       if [ -n "$DIRECTORY" ] ; then
@@ -299,7 +299,7 @@ cleanup() {
 
       # remove directory only if we used the default with process id inside the name
       if echo "$MNTPOINT" | grep -q '/mnt/debootstrap\.' ; then
-        if test -d "$MNTPOINT" ; then
+        if [ -d "$MNTPOINT" ] ; then
           einfo "Removing directory ${MNTPOINT}"
           rmdir "$MNTPOINT" || eend $?
         fi
@@ -346,6 +346,7 @@ stage() {
 
 # source main configuration file {{{
 if [ -r /etc/debootstrap/config ] ; then
+  bash -n /etc/debootstrap/config
   # shellcheck disable=SC1091
   . /etc/debootstrap/config
 fi
@@ -354,11 +355,10 @@ fi
 # cmdline handling {{{
 CMDLINE_OPTS=mirror:,iso:,release:,target:,mntpoint:,debopt:,defaultinterfaces,interactive,nodebootstrap,nointerfaces,nokernel,nopackages,filesystem:,config:,confdir:,packages:,chroot-scripts:,scripts:,post-scripts:,pre-scripts:,debconf:,vm,vmfile,vmsize:,vmefi,keep_src_list,hostname:,password:,nopassword,grmlrepos,backportrepos,bootappend:,grub:,efi:,arch:,insecure,verbose,help,version,force,debug,contrib,non-free,remove-configs,sshcopyid,sshcopyauth
 
-_opt_temp=$(getopt --name grml-debootstrap -o +m:i:r:t:p:c:d:vhV --long \
-  $CMDLINE_OPTS -- "$@")
-
-if [ $? != 0 ]; then
-  eerror "Try 'grml-debootstrap --help' for more information."; eend 1; exit 1
+if ! _opt_temp=$(getopt --name grml-debootstrap -o +m:i:r:t:p:c:d:vhV --long \
+  $CMDLINE_OPTS -- "$@"); then
+  eerror "Try 'grml-debootstrap --help' for more information."
+  bailout 1
 fi
 eval set -- "$_opt_temp"
 
@@ -658,6 +658,7 @@ fi
 # source specified configuration file {{{
 if [ -n "$CONFIGFILE" ] ; then
   einfo "Reading specified config file $CONFIGFILE."
+  bash -n "$CONFIGFILE"
   # shellcheck disable=SC1091 source=config
   if ! . "$CONFIGFILE" ; then
     eerror "Error reading config file $CONFIGFILE" ; bailout 1
@@ -1051,8 +1052,7 @@ elif [ -n "$INTERACTIVE" ] ; then
 Is this ok for you? Notice: selecting 'No' will exit ${PN}."
 
    dialog --title "$PN" --no-collapse \
-          --yesno "$INFOTEXT" 0 0
-   [ $? -eq 0 ] || bailout 0
+          --yesno "$INFOTEXT" 0 0 || bailout 0
 
 else # if not running automatic installation display configuration and prompt for execution:
    einfo "$PN [${VERSION}] - Please recheck configuration before execution:"
@@ -1451,7 +1451,7 @@ prepare_vm() {
   fi
 
   # make sure loop module is present and a usable loop device exists
-  modprobe -q loop
+  modprobe loop || true
   if ! losetup -f >/dev/null 2>&1; then
     eerror "Error finding usable loop device"
     bailout 1
@@ -1459,7 +1459,7 @@ prepare_vm() {
 
   # if dm-mod isn't available then kpartx will fail with
   # "Is device-mapper driver missing from kernel? [...]"
-  modprobe -q dm-mod
+  modprobe dm-mod || true
   if ! grep -q 'device-mapper' /proc/misc >/dev/null 2>&1 ; then
     eerror "Device-mapper support missing in kernel."
     bailout 1
@@ -1483,7 +1483,7 @@ prepare_vm() {
     if [ "$ARCH" = 'arm64' ]; then
       einfo "Setting up GPT partitions for arm64"
       parted -s "${TARGET}" 'mklabel gpt'
-      parted -s "${TARGET}" 'mkpart EFI fat32 1MiB 10MiB'
+      parted -s "${TARGET}" 'mkpart ESP fat32 1MiB 10MiB'
       parted -s "${TARGET}" 'set 1 boot on'
       parted -s "${TARGET}" 'mkpart LINUX ext4 10MiB 100%'
     else
@@ -1548,8 +1548,8 @@ grub_install() {
   fi
 
   if [ -n "${ARM_EFI_TARGET}" ]; then
-    mkdir -p "${MNTPOINT}/boot/efi"
-    if ! mount "${ARM_EFI_TARGET}" "${MNTPOINT}/boot/efi" ; then
+    mkdir -p "${MNTPOINT}"/boot/efi
+    if ! mount "${ARM_EFI_TARGET}" "${MNTPOINT}"/boot/efi ; then
       eerror "Error: Mounting ${ARM_EFI_TARGET} failed, can not continue."
       bailout 1
     fi
@@ -1682,7 +1682,7 @@ grub_install() {
   umount "${MNTPOINT}"/dev/pts
   try_umount 3 "${MNTPOINT}"/dev
 
-  if [ -n "$VMEFI" ]; then
+  if findmnt "${MNTPOINT}"/boot/efi &>/dev/null ; then
     umount "${MNTPOINT}"/boot/efi
   fi
 
@@ -1695,8 +1695,8 @@ umount_target() {
      return 0
   fi
 
-  if [ -n "${ARM_EFI_TARGET}" ]; then
-    umount "${MNTPOINT}/boot/efi"
+  if findmnt "${MNTPOINT}"/boot/efi &>/dev/null ; then
+    umount "${MNTPOINT}"/boot/efi
   fi
 
   umount "${MNTPOINT}"
@@ -2151,7 +2151,7 @@ for i in format_efi_partition prepare_vm mkfs tunefs \
          preparechroot execute_pre_scripts chrootscript execute_post_scripts \
          remove_configs umount_chroot grub_install umount_target fscktool ; do
     if stage "${i}" ; then
-      "$i" || bailout 2 "$i"
+      "$i"
       stage "${i}" 'done'
       rm -f "${STAGES}/${i}"
     fi